PROGRAM_NAME='Clearone Converge Pro 2 Example'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 03/20/2017  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)

/////////////////////////////////////////////////////////////
// IN ORDER TO VIEW THE CODE IN THIS PROJECT CORRECTLY,
// PLEASE SET YOUR NETLINX STUDIO EDITOR SETTINGS TO:
// TAB STOP CHARACTERS: 2
// INDENT BEFORE TEXT: 2
/////////////////////////////////////////////////////////////

DEFINE_DEVICE

dvDSP										= 0:3:0				// Clearone Converge Pro 2 IP
//dvDSP 									= 5001:1:0	  // Clearone Converge Pro 2 RS 232

dvPanelFader1						= 10002:01:0	// Any G4 Panel
dvPanelFader2						= 10002:02:0
dvPanelMic1							= 10002:03:0
dvPanelMic2							= 10002:04:0
dvPanelMic3							= 10002:05:0
dvPanelSpeakers					= 10002:06:0
dvPanelMic1ResponseTime	= 10002:07:0
dvPanelMic1TargetLevel	= 10002:08:0
dvPanelMic1HoldTime			= 10002:09:0
dvPanelMic1Chairman			= 10002:10:0
dvPanelMatrix						= 10002:12:0
dvPanelRoom							= 10002:13:0
dvPanelAnalogDialer			= 10002:14:0
dvPanelATCRX						= 10002:15:0
dvPanelVOIPDialer				= 10002:16:0
dvPanelVOIPRX						= 10002:17:0
dvPanelPresets					= 10002:18:0
dvPanelMacros						= 10002:19:0

vdvDSP									= 41001:01:0	// Clearone Converge Pro 2 Duet Main Communication Device 
vdvFader1								= 41001:01:0
vdvFader2								= 41001:02:0
vdvMic1									= 41001:03:0
vdvMic2									= 41001:04:0
vdvMic3									= 41001:05:0
vdvSpeakers							= 41001:06:0
vdvMic1ResponseTime			= 41001:07:0
vdvMic1TargetLevel			= 41001:08:0
vdvMic1HoldTime					= 41001:09:0
vdvMic1Chairman					= 41001:10:0
vdvMic1ToRecord					= 41001:11:0	
vdvMic1ToSpare1					= 41001:12:0	
vdvMic1ToSpare2					= 41001:13:0	
vdvMic1ToSpeakers				= 41001:14:0	
vdvMic2ToRecord					= 41001:15:0	
vdvMic2ToSpare1					= 41001:16:0	
vdvMic2ToSpare2					= 41001:17:0	
vdvMic2ToSpeakers				= 41001:18:0	
vdvFader1ToRecord				= 41001:19:0	
vdvFader1ToSpare1				= 41001:20:0	
vdvFader1ToSpare2				= 41001:21:0	
vdvFader1ToSpeakers			= 41001:22:0	
vdvFader2ToRecord				= 41001:23:0	
vdvFader2ToSpare1				= 41001:24:0	
vdvFader2ToSpare2				= 41001:25:0	
vdvFader2ToSpeakers			= 41001:26:0	
vdvRoomWall1						= 41001:27:0
vdvRoomWall2						= 41001:28:0
vdvRoomWall3						= 41001:29:0
vdvAnalogDialer					= 41001:30:0
vdvATCRX								= 41001:31:0
vdvVOIPDialer						= 41001:32:0
vdvVOIPRX								= 41001:33:0

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

Integer RoomWallsButtons[] =
{
	1,2,3
}

///////////////////////////////////////////////////////////
// Room State Objects
///////////////////////////////////////////////////////////
VOLATILE DEV vdvRoomStates[] =
{
	vdvRoomWall1,
	vdvRoomWall2,
	vdvRoomWall3
}

///////////////////////////////////////////////////////////
// Crosspoints
///////////////////////////////////////////////////////////
VOLATILE DEV vdvMMXPoints[] = 
{	
	vdvMic1ToRecord,
	vdvMic1ToSpare1,
	vdvMic1ToSpare2,
	vdvMic1ToSpeakers,
	vdvMic2ToRecord,
	vdvMic2ToSpare1,
	vdvMic2ToSpare2,
	vdvMic2ToSpeakers,
	vdvFader1ToRecord,
	vdvFader1ToSpare1,
	vdvFader1ToSpare2,
	vdvFader1ToSpeakers,
	vdvFader2ToRecord,
	vdvFader2ToSpare1,
	vdvFader2ToSpare2,
	vdvFader2ToSpeakers
}

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

DEFINE_MODULE 'Clearone_ConvergePro2_Comm_dr1_0_0' modClearoneConvergePro2(vdvDSP, dvDSP)

DEFINE_MODULE 'ClearoneConvergePro2GainMute' modFader1(vdvFader1, dvPanelFader1)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modFader2(vdvFader2, dvPanelFader2)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modMic1(vdvMic1, dvPanelMic1)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modMic2(vdvMic2, dvPanelMic2)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modMic3(vdvMic3, dvPanelMic3)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modSpeakers(vdvSpeakers, dvPanelSpeakers)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modATCRX(vdvATCRX, dvPanelATCRX)
DEFINE_MODULE 'ClearoneConvergePro2GainMute' modVOIPRX(vdvVOIPRX, dvPanelVOIPRX)
DEFINE_MODULE 'ClearoneConvergePro2EPLevel' modMic1ResponseTime(vdvMic1ResponseTime, dvPanelMic1ResponseTime)
DEFINE_MODULE 'ClearoneConvergePro2EPLevel' modMic1TargetLevel(vdvMic1TargetLevel, dvPanelMic1TargetLevel)
DEFINE_MODULE 'ClearoneConvergePro2EPLevel' modMic1HoldTime(vdvMic1HoldTime, dvPanelMic1HoldTime)
DEFINE_MODULE 'ClearoneConvergePro2EPState' modMic1Chairman(vdvMic1Chairman, dvPanelMic1Chairman)
DEFINE_MODULE 'ClearoneConvergePro2RoomState' modRoomWalls(vdvRoomStates, dvPanelRoom, RoomWallsButtons)
DEFINE_MODULE 'ClearoneConvergePro2AnalogDialer' modAnalogDialer(vdvAnalogDialer, dvPanelAnalogDialer)
DEFINE_MODULE 'ClearoneConvergePro2VOIPDialer' modVOIPDialer(vdvVOIPDialer, dvPanelVOIPDialer)
DEFINE_MODULE 'ClearoneConvergePro2Macros' modMacros(vdvDSP, dvPanelMacros)
DEFINE_MODULE 'ClearoneConvergePro2Presets' modPresets(vdvDSP, dvPanelPresets)
DEFINE_MODULE 'ClearoneConvergePro2MatrixMixer' modMatrixMixer(dvPanelMatrix, vdvMMXPoints);

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[vdvDSP]
{
	ONLINE:
	{
		WAIT 50
		{
	    SEND_COMMAND vdvDSP,'DEBUG-4'
	    
	    // IP Device?
	    IF (dvDSP.NUMBER == 0)
	    {
				SEND_COMMAND vdvDSP,'PROPERTY-IP_Address,192.168.187.53'
				SEND_COMMAND vdvDSP,'PROPERTY-User_Name,clearone'
				SEND_COMMAND vdvDSP,'PROPERTY-Password,converge'
				SEND_COMMAND vdvDSP,'PROPERTY-Poll_Time,0'
	    }
	    // Serial Device
	    ELSE
	    {
				SEND_COMMAND vdvDSP,'PROPERTY-Baud_Rate,38400'
	    }
	    
	    ////////////////////////////////////////////////////////
	    // Configure Clearone Virtual Devices
	    ////////////////////////////////////////////////////////
	    
	    // Faders //
	    // AUDIOPROCADD-<PORT>,GAINMUTE[<EndPointName>|<GAIN/GAIN_FINE>|<STEP>]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader1.PORT),',GAINMUTE[Fader_1|GAIN|2]'"
	    SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader2.PORT),',GAINMUTE[Fader_2|GAIN|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1.PORT),',GAINMUTE[Mic-01|GAIN_FINE|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic2.PORT),',GAINMUTE[Mic-02|GAIN_FINE|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic3.PORT),',GAINMUTE[Mic-03|GAIN_FINE|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvSpeakers.PORT),',GAINMUTE[Speakers|GAIN|1]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvATCRX.PORT),',GAINMUTE[Dialer_1_Rx|GAIN|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvVOIPRX.PORT),',GAINMUTE[Voip_1_Rx|GAIN|2]'"
			
			// EP_LEVEL //
			// AUDIOPROCADD-<PORT>,EP_LEVEL[<EndPointName>|<BlockName>|<ParameterName>|<MAX>|<MIN>|<STEP>]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1ResponseTime.PORT),',EP_LEVEL[Mic-01|AGC|RESPONSE_TIME|10000|100|1]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1TargetLevel.PORT),',EP_LEVEL[Mic-01|AGC|TARGET_LEVEL|20|-30|.5]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1HoldTime.PORT),',EP_LEVEL[Mic-01|GATING|HOLD_TIME|8|.1|.1]'"
			
			// EP_States
			// AUDIOPROCADD-<PORT>,EP_STATE[<EndPointName>|<BlockName>|<ParameterName>]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1Chairman.PORT),',EP_STATE[Mic-01|GATING|CHAIRMAN]'"
			
			// Crosspoints
			// XPOINT[<InputEndPointName>|<OutputEndPointName>|<MAX>|<MIN>|<Type>]
			// Valid values for Type: CROSSPOINT, GATED, NONGATED, PREAEC
			// Types GATED, NONGATED and PREAEC apply only to MIC end points.
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1ToRecord.PORT),',XPOINT[Mic-01|Record|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1ToSpare1.PORT),',XPOINT[Mic-01|Spare_1|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1ToSpare2.PORT),',XPOINT[Mic-01|Spare_2|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic1ToSpeakers.PORT),',XPOINT[Mic-01|Speakers|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic2ToRecord.PORT),',XPOINT[Mic-02|Record|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic2ToSpare1.PORT),',XPOINT[Mic-02|Spare_1|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic2ToSpare2.PORT),',XPOINT[Mic-02|Spare_2|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvMic2ToSpeakers.PORT),',XPOINT[Mic-02|Speakers|12|-20|GATED]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader1ToRecord.PORT),',XPOINT[Fader_1|Record|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader1ToSpare1.PORT),',XPOINT[Fader_1|Spare_1|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader1ToSpare2.PORT),',XPOINT[Fader_1|Spare_2|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader1ToSpeakers.PORT),',XPOINT[Fader_1|Speakers|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader2ToRecord.PORT),',XPOINT[Fader_2|Record|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader2ToSpare1.PORT),',XPOINT[Fader_2|Spare_1|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader2ToSpare2.PORT),',XPOINT[Fader_2|Spare_2|12|-20|CROSSPOINT]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvFader2ToSpeakers.PORT),',XPOINT[Fader_2|Speakers|12|-20|CROSSPOINT]'"
			
			// RM_STATE //
			// AUDIOPROCADD-<PORT>,RM_STATE[<RoomNumber>|<RoomOption>|<DividerNumber>]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvRoomWall1.PORT),',RM_STATE[1|IndividualDividerState|1]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvRoomWall2.PORT),',RM_STATE[1|IndividualDividerState|2]'"
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvRoomWall3.PORT),',RM_STATE[1|IndividualDividerState|3]'"
			
			// AUDIOPROCADD-<PORT>,DIALER[<EndPointName]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvAnalogDialer.PORT),',DIALER[Dialer_1_Rx]'"
			
			// AUDIOPROCADD-<PORT>,VOIP[<EndPointName]
			SEND_COMMAND vdvDSP,"'AUDIOPROCADD-',ITOA(vdvVOIPDialer.PORT),',VOIP[Voip_1]'"
			
	    SEND_COMMAND vdvDSP,'REINIT'
			
		}
	}
}

(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)

